import { useEffect, useState } from "react";
import "./App.css";
import Layout from "./components/base/layout";
import Form from "./components/top-level/form";
import Tasks from "./components/top-level/tasks";

function App() {
  const [task, setTask] = useState([]);
  const addTask = async (data) => {
    const res = await fetch(`http://192.168.1.91:5000/task`, {
      method: "POST",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(data),
    });
    const result = await res.json();
    setTask([...task, result]);
  };

  const getTask = async () => {
    const taskData = await fetch("http://192.168.1.91:5000/task");
    const response = await taskData.json();
    setTask(response);
  };
  const getTaskById = async (id) => {
    const tasktracker = await fetch(`http://192.168.1.91:5000/task/${id}`);
    const response = await tasktracker.json();
    return response;
  };
  const remainder = async (id) => {
    const toogle = await getTaskById(id);
    const result = { ...toogle, isCompleted: !toogle.isCompleted };

    const res = await fetch(`http://192.168.1.91:5000/task/${id}`, {
      method: "PUT",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(result),
    });
    const data = await res.json();
    setTask(
      task.map((e) =>
        e.id === data.id ? { ...e, isCompleted: data.isCompleted } : e
      )
    );
  };
  const deleteTask = async (id) => {
    await fetch(`http://192.168.1.91:5000/task/${id}`, {
      method: "DELETE",
    });
    setTask(task.filter((e) => e.id !== id));
  };
  useEffect(() => {
    getTask();
  }, []);

  return (
    <div className="App">
      <Layout count={task.filter((e) => !e.isCompleted).length}>
        {task.length > 0 ? (
          <Tasks tasklist={task} remainder={remainder} deleted={deleteTask} />
        ) : (
          <h3>No task</h3>
        )}
        <Form onSubmit={addTask} />
      </Layout>
    </div>
  );
}

export default App;
