import { useState } from "react";
import Button from "../../base/button";
import Input from "../../base/input";
import "./form.css";

function Form({ onSubmit }) {
  const [title, setTitle] = useState("");
  const handleSubmit = (e) => {
    e.preventDefault();

    onSubmit({ title, isCompleted: false });
    setTitle("");
  };

  return (
    <div className="form-section">
      <form onSubmit={handleSubmit}>
        <Input
          required
          value={title}
          onChange={(e) => setTitle(e.target.value)}
        />

        <Button>Submits</Button>
      </form>
    </div>
  );
}

export default Form;
