import { FaTimesCircle } from "react-icons/fa";
import Checkbox from "../../base/checkbox";

import "./task.css";
function Task({ title, isCompleted, onDelete, onChange }) {
  const handleDelete = () => {
    const dialog = window.confirm("Do you want to delete?");
    if (dialog) {
      onDelete();
      return true;
    }
    return false;
  };
  const handleChange = (e) => {
    e.preventDefault();
    onChange();
  };
  return (
    <div className="task-section">
      <Checkbox onChange={handleChange} checked={isCompleted} />
      <p className={`${isCompleted ? "strike-through" : ""}`}>{title}</p>

      <FaTimesCircle className="fa-close" onClick={handleDelete} />
    </div>
  );
}

export default Task;
